'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _component = require('./component');

var _component2 = _interopRequireDefault(_component);

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _normalize = require('./normalize');

var _normalize2 = _interopRequireDefault(_normalize);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Client = function (_Component) {
  _inherits(Client, _Component);

  _createClass(Client, [{
    key: 'defaults',


    /**
     * @ignore
     */
    value: function defaults() {
      return {
        root: '/', // base url

        // throw Error on non-OK response?
        errors: true,

        fetch: {
          algo: _isomorphicFetch2.default,
          options: {
            credentials: 'same-origin'
          }
        }
      };
    }
  }]);

  function Client() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Client);

    var _this = _possibleConstructorReturn(this, (Client.__proto__ || Object.getPrototypeOf(Client)).call(this, options));

    _this.options = _lodash2.default.merge(_this.defaults(), options);
    return _this;
  }

  /**
   * The fetch implementation
   * @type {Function}
   */


  _createClass(Client, [{
    key: 'url',


    /**
     * Derive a fully qualified URL from the url root and the given path
     * @param {String} path
     * @return {String}
     */
    value: function url() {
      return '' + this.root + _normalize2.default.path.apply(_normalize2.default, arguments);
    }

    /**
     * Create a fetch request options object
     * @param {Object} options
     * @return {Object}
     */

  }, {
    key: 'fopts',
    value: function fopts() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      return _extends({}, this.option('fetch').options, options);
    }
  }, {
    key: 'fetch',
    get: function get() {
      if (!this._fetch) {
        this._fetch = this.option('fetch').algo;
      }
      return this._fetch;
    }

    /**
     * The fetch implementation
     * @type {Function}
     */
    ,
    set: function set(fetch) {
      this._fetch = fetch;
    }

    /**
     * The URL root
     * @readonly
     * @type {String}
     */

  }, {
    key: 'root',
    get: function get() {
      return _normalize2.default.url(this.option('root'));
    }
  }], [{
    key: 'createMethod',
    value: function createMethod(method) {
      Client.prototype[method] = function (path) {
        var _this2 = this;

        var fopts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        return this.fetch(this.url(path), this.fopts(_extends({}, fopts, {
          method: method.toUpperCase()
        }))).then(function (response) {
          if (!response.ok && _this2.option('errors')) {
            var e = new Error('got non-OK response');
            e.response = response;
            throw e;
          }
          return response;
        });
      };
    }
  }]);

  return Client;
}(_component2.default);

['head', 'get', 'put', 'delete', 'post', 'patch'].forEach(Client.createMethod);

exports.default = Client;
module.exports = exports['default'];