'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path2 = require('path');

var _path3 = _interopRequireDefault(_path2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {

  /**
   * @param {String} url
   * @return {String}
   */
  url: function url(_url) {
    if (_url.indexOf('http') === 0) {

      // strip trailing slash if the url is fully qualified
      if (_url[_url.length - 1] === '/') {
        return _url.slice(0, -1);
      }
    }

    if (_url === '//') {
      return '/';
    }

    return _url;
  },


  /**
   * @param {String} path
   * @return {String}
   */
  path: function path() {
    var output = _path3.default.normalize(_path3.default.join.apply(_path3.default, arguments));

    if (!output.length) {
      return '/';
    }
    if (output[0] !== '/') {
      return '/' + output;
    }
    return output;
  }
};
module.exports = exports['default'];