import path from 'path';

export default {

  /**
   * @param {String} url
   * @return {String}
   */
  url (url) {
    if (url.indexOf('http') === 0) {

      // strip trailing slash if the url is fully qualified
      if (url[url.length - 1] === '/') {
        return url.slice(0, -1);
      }
    }

    if (url === '//') {
      return '/';
    }

    return url;
  },

  /**
   * @param {String} path
   * @return {String}
   */
  path (...tokens) {
    let output = path.normalize(path.join(...tokens));

    if (!output.length) {
      return '/';
    }
    if (output[0] !== '/') {
      return `/${output}`;
    }
    return output;
  },

};
